/*
 * Created on: Jul 28, 2024
 */

#ifndef USER_SRC_LED_H_
#define USER_SRC_LED_H_



#include <stdint.h>

#include "aw20xxx.h"

#include "ledprog_boeing.h"
#include "ledprog_flames.h"



#define BOEING_TIM      TIM3
#define BOEING_COUNT    4


typedef struct LedMatrix {
    union {
        uint8_t all[18];
        struct ind {
            uint8_t rgb[5][3];
            uint8_t led[3];

        } ind;
    };
} LedMatrix;



extern struct LedMatrix led;
extern uint8_t boeing[4];



void use_brightest(uint8_t *dest, uint8_t *compare, uint8_t count);

void led_init();

void led_matrix_is_updated();
void led_matrix_send();

void led_boeing_update();



#endif /* USER_SRC_LED_H_ */
